////////////////////////////////////////////////////////////////////////////
// FAST CONFIG Test Beispiel
// 
//
// Datei:	FastConfig.h
// 
// Copyrights by Silicon Software 2003
//
////////////////////////////////////////////////////////////////////////////

#ifndef FASTCONFIG_H
#define FASTCONFIG_H

#include <math.h>

#include <stdio.h>
#include <time.h>

#include "fgrab_struct.h"
#include "fgrab_prototyp.h"
#include "fgrab_define.h"

#define CONTDMA


////////////////////////////////////////////////////////////////////////////
#define  MAXPICS   20	 // Aufnahme von MaxPics Bildern
#define  EXPAMP    1     // amplification of the exposure (1=2 kHz, 10=0.5 kHz)
#define  ONTHEFLY  false

#define		DEF_MAXX		600
#define		DEF_MAXY		600
#define		DEF_MINDX		12
#define		DEF_THR1		0
#define		DEF_THR2		100
#define		DEF_WIDTH		400
#define		DEF_HEIGHT		100

////////////////////////////////////////////////////////////////////////
// Main Funktion
//

#define FC_FAST_CONFIG			0x00
#define FC_GENERATE_EXSYNC		0x01
#define FC_XLEN_LSB				0x02
#define FC_XLEN_MSB				0x03

#define FC_WAIT_NCYCLE			0x04
#define FC_WAIT_UNTILFVAL		0x05

#define FC_YLEN_LSB				0x06
#define FC_YLEN_MSB				0x07

#define FC_DEADTIME_REG0		0x08
#define FC_DEADTIME_REG1		0x09
#define FC_DEADTIME_REG2		0x0a
#define FC_DEADTIME_REG3		0x0b

#define FC_IMGNR_REG2			0x0e
#define FC_IMGNR_REG3			0x0f

////////////////////////////////////////////////////////////////////////

#define FC_INIT_ERROR	-10
#define FC_PARAM_ERROR  -20 

////////////////////////////////////////////////////////////////////////

extern "C" int clSerialInit		(unsigned long serialIndex, void** serialRefPtr);
extern "C" void clSerialClose	(void* serialRef);
extern "C" int clSerialRead		(void* serialRef, char * buffer,unsigned long * bufferSize,unsigned long serialTimeOut);
extern "C" int clSerialWrite	(void* serialRef, char * buffer,unsigned long * bufferSize,unsigned long serialTimeOut);


typedef struct FC_ParameterSet_s {
	int		RoiPosX, RoiWidth, RoiPosY, RoiHeight;
	double	ExposureInMicroSec;
	double	FrameTimeInMicroSec;
	int		UseLinLog2;
	double  dLinlog1,dLinlog2,dComp;
} FC_ParameterSet;

extern "C" int writeParameterSet(Fg_Struct *fg,FC_ParameterSet *paramSet,int set,int imgnr,int doInit,int port);

extern "C" int setParameterSetRoi(FC_ParameterSet *paramSet, int roiPosX, int roiWidth, int roiPosY,int roiHeight);
extern "C" int setParameterSetTime(FC_ParameterSet *paramSet, double exposureInMicroSec, double frameTimeInMicroSec);
extern "C" int setParameterSetLinlog(FC_ParameterSet *paramSet, int useLinLog2, double dLinlog1,double dLinlog2, double dComp);

extern "C" int FastConfigInit	(int pPort);
extern "C" int FastConfigFree	(int pPort);

extern "C" int clInit			(void** ref,int nr);
extern "C" int clClose			(void *ref);
extern "C" int clPfRegWrite		(void *ref,int address,unsigned char byte);
extern "C" int clPfRegRead		(void *ref,int address,unsigned char* byte);
extern "C" int lockPfCamera		(int port);
extern "C" int unlockPfCamera	(int port);
 
extern "C" void setCmdBuffer					(FastConfigPageCmd  *mFcpc,unsigned char cmd,unsigned char data);
extern "C" void setWindowSisoFg					(FastConfigPageCmd  *mFcpc,int pwidth,int pheight);
extern "C" void setDeadTimeSisoFg				(FastConfigPageCmd  *mFcpc,int deadTimeInMicroSec);
extern "C" void setWaitNcycleSisoFg				(FastConfigPageCmd  *mFcpc,int timeInMicroSec);
extern "C" void setWaitUntilFvalSisoFg			(FastConfigPageCmd  *mFcpc);
extern "C" void setImgNumSisoFg					(FastConfigPageCmd  *mFcpc,unsigned long imgNr);
extern "C" void setGenExsyncSisoFg				(FastConfigPageCmd  *mFcpc);

extern "C" void writeFastConfigRegisterPfCamera	(FastConfigPageCmd  *mFcpc,int addr,int value);
extern "C" void setRoiPfCamera					(FastConfigPageCmd  *mFcpc,int x,int width,int y,int height);
extern "C" void setUpdatePfCamera				(FastConfigPageCmd  *mFcpc);
extern "C" void setExposurePfCamera				(FastConfigPageCmd  *mFcpc,int exposureTimeInMicroSec);
extern "C" void setLinlog2PfCamera				(FastConfigPageCmd  *mFcpc,double dLinlog1,double dLinlog2,double dComp,int IExposureTimeInMicroSec,int port) ;
extern "C" void setLinlog2PfCameraOff			(FastConfigPageCmd  *mFcpc,int port);

#endif
