
//+-------------------------------------------------------------------
//
//  
//  Copyright (C) Silicon Software GmbH, 1998-99.
//
//  File:       fgrab.h
//
//  Contents:   
//              
//
//
//--------------------------------------------------------------------

#ifndef __FGRABH
#define __FGRABH

#include <stdio.h>
#include "os_type.h"

#ifdef _WINNT
#include <windows.h>
#endif

#ifdef __cplusplus
extern "C" {
#endif


#ifndef LINUX
typedef int (*hap_func)(void*,int, void*);
#endif

#define MAX_HASH_VAL 4096
#define MAX_BUF_NR 65536
#define ME_USER_BUFFER 0x100
#define ME_LOCKED_BUFFER 0x200
#define LINECAM300

#ifdef LINECAM300
#define ZEILENVERSATZKORREKTUR
#endif

///////////////////////////////////////////////////////////////
//
// Name		: fg_para_s
// Typ		: fg_para
//			: Parameterstruktur 
//

/*
typedef struct fg_para_s {
	volatile unsigned long *ptr;
	int height;
	int width;
	int nr;
	int sim_param;
	int sim_flag;
	int xoff;
	int yoff;
	int xdummy;
	int format;
	int scale;
	int length;
	float matrix[9];
	int zv;
	int zv_dir;
	int trig_on;
	int extsync;
//	int dir;

	int cam_nr;
	int opto_out;
	int trigger_val;
	int trigger_chan;
	int	timeout;
	int lognum;
	int ctrl_reg;	// hlt Zustand von trig,ext_reset und cam_sel
	int port;
	int bitdepth;
	int bit_alignment;
	int line_alignment;
	int cambitwidth;
	struct HWND__ *hwnd;
	int last_transfer_length;
	int act_pic_nr;
	int transfer_flag;
	void *user_data;
} fg_para_t;
*/
//typedef fg_par dummy;


///////////////////////////////////////////////////////////////
//
// Name		: Fg_Info_s
// Typ		: Fg_Info
//			: 
//

typedef int (*FGFUNC)(void *pFg,...);
typedef int (*GeneralFunc)(int,int,int,int);

typedef struct Fg_Info_s
{
	unsigned long version;
	unsigned long size;
	HANDLE	 dll;
	FGFUNC  DLL_Fg_Init;
	FGFUNC  DLL_Fg_AllocMem;
	FGFUNC  DLL_Fg_AllocPhysMemLine;
	FGFUNC  DLL_Fg_LoadConfig;
	FGFUNC  DLL_Fg_FreeConfig;
	FGFUNC  DLL_Fg_Configure;
	FGFUNC  DLL_Fg_ConfigureEx;
	FGFUNC  DLL_Fg_SetClks;
	FGFUNC	DLL_Fg_SetParameter;
	FGFUNC	DLL_Fg_SetParameterActive;
	FGFUNC	DLL_Fg_GetParameter;
	FGFUNC  DLL_Fg_StartGrabbing;
	FGFUNC  DLL_Fg_StartGrabbingCont;
	FGFUNC  DLL_Fg_StopGrabbing;
	FGFUNC  DLL_Fg_StopTransfer;
	FGFUNC  DLL_Fg_TestDDStatus;
	FGFUNC	DLL_Fg_WaitTransfer;
	FGFUNC  DLL_Fg_FreeMem;
	FGFUNC  DLL_Fg_FreeGrabber;
	FGFUNC  DLL_Fg_SetExternSignal;
	FGFUNC  DLL_Fg_GetExternSignal;	
	FGFUNC  DLL_Fg_TriggerOn;
	FGFUNC  DLL_Fg_SetTrigger;
	FGFUNC  DLL_Fg_ResetTrigger;
	FGFUNC  DLL_write_bmp_24;
	FGFUNC  DLL_Fg_SetActBuffer;
	FGFUNC  DLL_Fg_GetLastError;
	FGFUNC  DLL_Fg_GetErrorCode;
	FGFUNC  DLL_Fg_SwapBuffer;
	FGFUNC  DLL_Fg_GetSerialNumber;
	FGFUNC  DLL_Fg_ResetCam;
	FGFUNC  DLL_Fg_CamSel;
	FGFUNC  DLL_Fg_ExtSync;
	FGFUNC  DLL_Fg_GetImagePtr;
	FGFUNC  DLL_Fg_GetImagePtrEx;
	FGFUNC  DLL_Fg_DoDialog;
	FGFUNC  DLL_Fg_SetConfig;
	FGFUNC  DLL_Fg_GetConfig;
	FGFUNC  DLL_Fg_SerialSend;
	FGFUNC  DLL_Fg_SerialReceive;
	FGFUNC  DLL_Fg_ReadParameter;
	FGFUNC  DLL_Fg_SaveParameter;
	FGFUNC  DLL_INFO;
	FGFUNC  DLL_Fg_SerialReceiveTest;
	FGFUNC  DLL_Fg_SerialOpen;
	FGFUNC  DLL_Fg_SerialClose;
	GeneralFunc  *GeneralFunction;
	int     nr_of_gen_funcs;
	void	*fg_int;
#ifndef FG_INTERNAL
} Fg_Info;
#else
#ifdef FGLIB
} Fg_Info;
#else
} Fg_Info_Ext;
#endif
#endif
/*
typedef struct fg_ctrl_s {
	unsigned long cmd;

	union {
		struct fg_init_s {
			int				size;	
			unsigned char * buf;	
			char			demand;
			int				buf_cnt;
		} fg_init;
	
		struct fg_start_s {
			int param;
			int timeout;
			int chan;
			int offset;
			int act_size;
			int mode;
			int act_buf;
 			int act_sub_buf;
		} fg_start;
	
		struct fg_stop_s {
			int chan;
		} fg_stop;

		struct fg_param_s {
			int id;
			int param;
		} fg_param;
	
		struct fg_buf_s {
			int nr;	
		} fg_buf;

		struct fg_test_s {
			int param;
		} fg_test;
		struct fg_mapinfo_s {
			int param;
		} fg_mapinfo;

	} u;
} fg_ctrl_t;
*/

typedef struct Fg_Design_s {
	int		design_is_load;
	fpga_design	*design;
} Fg_Design;

#define TIMEOUTVAL	15

#define FG_CTRL 0x20 // !!! Noch ersetzen !!!

#define FG_INIT			0x10
#define FG_START		0x20
#define FG_ALLOC_MEM	0x30
#define FG_STOP			0x40
#define FG_PARAMETER	0x50
#define FG_SELECTBUFFER 0x60
#define	FG_FREE			0x70
#define FG_TEST			0x80
#define FG_SETMAXBUF	0x90
#define FG_MAPINFO		0x100

// +-- Noch zu ersetzen --+

#define START_FUNC			0x1
#define TRANSFER_IS_ACTIVE	0x2
#define SET_PARAMETER		0x3 
#define GET_ACT_LINE_POS	0x4
#define	GET_STATUS			0x5

// +-- PARAMETER --+

#define FG_WIDTH	100
#define FG_HEIGHT	200
#define FG_XOFFSET	300
#define FG_YOFFSET	400
#define FG_DUMMY	500
#define FG_TIMEOUT	600
#define FG_FORMAT	700

// FORMATE
#define FG_GRAY		3
#define FG_COL16	1
#define RGB565		5
#define FG_COL24	2
#define RGB888		2
#define FG_COL8_32	3
#define FG_GRAY8_32	FG_COL8_32
#define FG_COL32	4
#define RGB888_32	FG_COL32
#define YUV422      6
#define FG_GRAY16_32	7	// Neues Format 16 Bit
#define FG_GRAY16	FG_GRAY16_32

#define FG_MODE	    1100
#define FG_SIMULATOR 1200
#define FG_SIM_PARAM 1250
#define FG_SCALE	1300
#define FG_MATRIX	1400
#define FG_EXTSYNC	1500

#define FG_BUF_CNT 1400
#define FG_CAM_TYPE 1500
#define FG_CAM_MANU 1600

#define FG_ZV		1700
#define FG_ZV_UP	1800
#define FG_ZV_DOWN	1900

#define FG_CAMSTATUS 2000
#define FG_PORT		3000

#define FG_BITDEPTH		4000
#define FG_BITALIGNMENT	4010
#define FG_LINEALIGNMENT	4020

#define FG_CAMBITWIDTH		 5000
#define FG_CAMBITSHIFT		 5010
#define FG_LASTTRANSFER_LEN  5200
#define FG_TRANSFER_LEN		 5210
#define FG_CLEARPICCNT		 5300

#define SINGLE_BUFFER	0x1
#define LINE_CAM		0x2

#define START_SYNC	0x1
#define START_ASYNC 0x2

#define STOP_SYNC	0x11
#define STOP_ASYNC	0x12

#define TRANSFER_ACTIVE 0x0

#define FG_CAM0 0x0
#define FG_CAM1 0x1

#define PORT_A 0
#define PORT_B 1

#define FG_MAXWIDTH		6100
#define FG_MAXHEIGHT	6200

#define FG_TRIGGER		8000
#define FG_TRIGGERMODE  8100
#define FG_EXSYNCFREQ   8200
#define FG_VINITMODE	8300 // Pulnix
#define FG_EXSYNC_HIGH	8400 
#define FG_EXSYNC_LOW	8500 
#define FG_EXSYNCMODE	8600 

#define FG_ACQDELAY		9000

// PULNIX Spezifika
#define FG_FPS				10010			// Frames_Per_Second (float)
#define FG_EXPOSURE			10020			// Exposure Time in s (Brigthness)	(float)
#define FG_TRIGGEROUT_DELAY 10030			// Verzgerungszeit des TRIGGER in s (float)
#define FG_HDPERIOD			10040			// HD-Sync in s (float)

// Die FG_CLOCKS
#define FG_FGCLOCK0         12010			// design_clk2
#define FG_FGCLOCK1         12020			// design_clk
#define FG_FGCLOCK2         12030			// plx_clk
#define FG_FGCLOCK3         12040			// fg_clk0
#define FG_FGCLOCK4         12050			// fg_clk1

// Bayer-Filter Cameras 
#define FG_GET_RED	    20000
#define FG_GET_BLUE	    20010

// Port Selection
#define FG_EXSYNC_PORT 22000

// FG_CAMSTATUS
#define CLK_DETECTED		0x1
#define HSYNC_DETECTED		0x2	
#define VSYNC_DETECTED		0x4
#define TRANSFER_ERROR_DETECTED	0x8
#define DETECTION_IMPLEMENTED 0x10
#define CAM_IMPLEMENTED	0x20

// Transfermodes
#define NO_TRANSFER		0
#define SINGLE_TRANSFER 10
#define CONT_TRANSFER	20

// +-----------------------------------------------------
// 
// Fehler Codes 
//
// +-----------------------------------------------------

#define FG_OK					0
#define FG_ERROR				-1
#define FG_ALR_INIT				-10	
#define	FG_NOT_AVAILABLE		-12
#define FG_WRONG_ARCHITECTURE	-50
#define FG_SIZE_ERROR			-200
#define FG_PTR_INVALID			-300
#define FG_RANGE_ERR			-400
#define FG_NOT_ENOUGH_MEM       -500
#define FG_PARAM_INVALID		-700	

#define WRONG_NUMBER_OF_BUFFER		-2010
#define TOO_MANY_BUFFER				-2011
#define FG_NOT_ENOUGH_MEMORY		-2020
#define FG_MEMORY_ALREADY_ALLOCATED	-2024
#define FG_NOT_INIT					-2001
#define FG_WRONG_SIZE				-2002
#define FG_INTERNAL_STATUS_ERROR	-2030
#define FG_INTERNAL_ERROR			-2031
#define FG_CANNOT_START				-2040
#define FG_CANNOT_STOP				-2042
#define FG_INVALID_DESIGN			-2050
#define FG_CONFIGURE_FAILED			-2052
#define FG_INVALID_MEMORY			-2060
#define FG_INVALID_PARAMETER		-2070
#define FG_NOT_LOAD					-2080
#define FG_ALREADY_STARTED			-2090
#define FG_STILL_ACTIVE				-2100
#define FG_NO_VALID_DESIGN			-2110
#define FG_TIMEOUT_ERR				-2120
#define FG_NOT_IMPLEMENTED			-2130

#define FG_ASYNC_OK		0
#define FG_SYNC_OK		0

// Hardware defines

#define HW_OPTOKOP_A 0x100
#define HW_OPTOKOP_B 0x120

#define HW_TRIGGER_A 0x200
#define HW_TRIGGER_B 0x220

#define HW_EXTSYNC_A 0x300
#define HW_EXTSYNC_B 0x320
 
#define HW_EXTCAMSEL_A 0x400
#define HW_EXTCAMSEL_B 0x420

#define HW_EXTRESET_A 0x500
#define HW_EXTRESET_B 0x520

#define DO_DYNAMIC	0x100
#define DO_STATIC   0x200

#define CONTMODE 0x10
#define CONTHANDSHAKEMODE 0x20

///////////////////////////////////////////////////
//
// Define for the external synchro signals
//


#define EXT_ON		1
#define EXT_OFF		0
#define EXT_HIGH	2
#define EXT_LOW		0

#define EXT_MODE_SOFTWARE	0x1
#define EXT_MODE_STROBE		0x2
#define EXT_MODE_PULSE		0x4
#define EXT_MODE_STARTSTOP	0x8
#define EXT_MODE_ABORT      0x10

#define EXT_MODE0	EXT_MODE_SOFTWARE
#define EXT_MODE1	0x10
#define EXT_MODE2	EXT_MODE_STROBE
#define EXT_MODE3	EXT_MODE_PULSE

#define EXT_LINETRIGGER	0x20
#define EXT_SINGLE_PULSE	0x40

#define ON				1
#define OFF				0

#define _8BIT			0
#define _16BIT			1

#define PULNIX_FREE_RUN				EXT_OFF				
#define PULNIX_GRABBER_CONTROLLED	EXT_MODE_SOFTWARE	
#define PULNIX_ASYNC_TRIGGER		EXT_MODE_PULSE		

#define FREE_RUN				EXT_OFF				
#define GRABBER_CONTROLLED		EXT_MODE_SOFTWARE	
#define ASYNC_TRIGGER			EXT_MODE_PULSE		

#define EXT_MODE_FREE_RUN				EXT_OFF				
#define EXT_MODE_GRABBER_CONTROLLED		EXT_MODE_SOFTWARE	
#define EXT_MODE_EXTERNAL_TRIGGER		EXT_MODE_PULSE		

// Interner Defines

#define MODE_SOFTWARE	0x0
#define MODE_STROBE		0x1
#define MODE_PULSE		0x2
#define MODE_STARTSTOP	0x3

#define NOLINETRIGGER	0x8
#define SINGLE_PULSE	0x4


///////////////////////////////////////////////////////
//
// Optocoupler modes
//

#define OPTO_INVERT 0x8

#define	OPTO_START	0x0
#define OPTO_STOP	0x1
#define OPTO_STROBE	0x2
#define OPTO_LINE	0x3

#define	FG_OPTO_START	0x10000
#define FG_OPTO_STOP	0x10010
#define FG_OPTO_STROBE	0x10020
#define FG_OPTO_LINE	0x10030

#define FG_SETSHADINGPARAM 0x11000

// +-----------------------------------------------------
// 
// Prototypes 
//
// +-----------------------------------------------------

#ifndef FG_INTERNAL

int				init_functions	(Fg_Info *pFg);
int				parameter_check	(Fg_Info *pFg, int id, void *param);

Fg_Info*		Fg_Init			(char *name,int nr);
//Fg_Info*		Fg_InitLocal	(int nr,int size);
int				Fg_ConfigureEx	(Fg_Info *pFg,int id);
int				Fg_Configure	(Fg_Info *pFg, Fg_Design *des);
int				Fg_LoadConfig	(Fg_Info *pFg, Fg_Design *des, char *name);
int				Fg_FreeConfig	(Fg_Info *pFg, Fg_Design *des);
unsigned long	*Fg_AllocMem	(Fg_Info *pFg, int size, unsigned long *log_nr, int nr_of_buf,int cam_nr);

int				Fg_StartGrabbing	(Fg_Info *pFg, int param,int cam_nr,FGFUNC f,char *);
int				Fg_StartGrabbingCont(Fg_Info *pFg,int mode,int pic_count,int cam_nr,FGFUNC func,char *f);
int				Fg_StopGrabbing		(Fg_Info *pFg);
int				Fg_TestDDStatus		(Fg_Info *pFg,int cam_nr);
int				Fg_WaitTransfer		(Fg_Info *pFg,int pic_nr,int cam_nr,int timeout);


int				Fg_SetActBuffer	 (Fg_Info *pFg, int sub_nr,int cam_nr);
int				Fg_SetClks		 (Fg_Info *pFg,Fg_Design *des,int plx, int fpga, int fpga2);
int				Fg_GetLastError	 (Fg_Info *pFg,char *str,int len);
int				Fg_GetErrorCode  (Fg_Info *pFg);
int				Fg_SetParameter	 (Fg_Info *pFg, int id, void  *param,int cam);
int				Fg_GetParameter	 (Fg_Info *pFg, int id, int cam);
int				Fg_GetParameterEx(Fg_Info *pFg, int id, int cam,int nParam);

long			Fg_GetExternSignal	(Fg_Info *pFg, int param);
int				Fg_SetExternSignal	(Fg_Info *pFg, int param,long signal);
int				Fg_SerialSend		(Fg_Info *pFg, int data,int cam);
int				Fg_SerialReceive	(Fg_Info *pFg,int cam);

int				Fg_SetTrigger		(Fg_Info *pFg, int trig,int cam);
int				Fg_TriggerOn		(Fg_Info *pFg,int sw,int cam);
int				Fg_ResetTrigger		(Fg_Info *pFg,int );

int				Fg_DesignStart		(Fg_Info *pFg);
int				Fg_SwapBuffer		(Fg_Info *pFg,int cam_nr);
int				Fg_SimpleTestStatus	(Fg_Info *pFg);
long			Fg_GetSerialNumber	(Fg_Info *pFg);

int				Fg_FreeGrabber		(Fg_Info *pFg);
int				Fg_StopTransfer		(Fg_Info *pFg,int chan);

int				Fg_MapInfo			(Fg_Info *pFg);

unsigned long	*Fg_GetImagePtr		(Fg_Info *pFg,int cam_nr);
unsigned long	*Fg_GetImagePtrEx	(Fg_Info *pFg,int nPicNr,int cam_nr);
int				Fg_ResetCam			(Fg_Info *pFg,int time,int cam_nr);
int				Fg_CamSel			(Fg_Info *pFg,int sel,int cam_nr);
int				Fg_ExtSync			(Fg_Info *pFg,int flag,int low,int high,int cam_nr);
int				Fg_FreeMem			(Fg_Info *pFg,int log_num,int cam_nr);
int				Fg_DoDialog			(Fg_Info *pFg,int flag,int hwnd,int id,int cam_nr);

////////////////////////////////////////////////////////////////////////
//
// General Function Schnittstelle
//

int Fg_GeneralFunctionInfo	(Fg_Info *pFg,int cmd,int index,char *str,int maxlen);
int Fg_GeneralFunction		(Fg_Info *pFg,int index,int cmd,int sub_cmd,int arg_in,int arg_out);

int Fg_SetErrMsg			(Fg_Info *pFg,char *str);
int Fg_SetErrMsg2			(Fg_Info *pFg,int err_nr,char *err_msg);

int Fg_GetConfig			(Fg_Info *pFg,char **data);
int Fg_SetConfig			(Fg_Info *pFg,void *data, int len);
int Fg_ReadParameter		(Fg_Info *pFg,char *name);
int Fg_SaveParameter		(Fg_Info *pFg,char *name);

int Fg_SetClks				(Fg_Info *pFg,Fg_Design *des,int plx, int fpga, int fpga2);

#endif

///////////////////////////////////////////////////////////////////////////
//
// BMP-Funktionen 
//

int write_bmp_8(char *name,char *data,int width,int height);
int write_bmp_24(char *name,char *data,int width,int height);

///////////////////////////////////////////////////////////////////////////
//
// Display Funktionen
//

int  CreateDisplay	(int nColor,int nWidth,int nHeight);
void SetBufferWidth	(int nId,int nWidth,int nHeight);
void SetBuffer		(int nId,unsigned long *ulpBuf);
void DrawBuffer		(int nId,unsigned long *ulpBuf,int nNr,char *cpStr);
void CloseDisplay	(int nId);

#ifdef __cplusplus
}
#endif

#endif


