//+-------------------------------------------------------------------
//
//  
//  Copyright (C) Silicon Software GmbH, 2002-2005.
//
//  File:       fgrab_define.h
//
//
//	
// ----------------------------------------------------------------------------+


#ifndef __FGRABDEFINE_H
#define __FGRABDEFINE_H

#include "menable.h"

enum RowFilterModes {
  _NON_TRIGGERED_EOF_CONTROLLED=0,				// reg=0x00 
  _NON_TRIGGERED_LINE_COUNT_CONTROLLED=0x1,		// reg=0x10 
  _TRIGGERED_EOF_CONTROLLED=0x2,				// reg=0x20 
  _TRIGGERED_LINE_COUNT_CONTROLLED=0x3};	

enum TriggerMode    {
  _GRABBER_CONTROLLED_=0,								// reg=0x0     
  _GRABBER_CONTROLLED_STROBE=1,							// reg=0x1
  _GRABBER_CONTROLLED_TRIGGER=2,						// reg=0x2
  _SINGLE_SHOT=4,										// reg=0x4
  _EXTERNAL_TRIGGER=6};									// reg=0x5 or 0x6

enum LineTriggerMode  {
	_LRM_AUTO=0,         // auto generated line trigger output (VINIT)
	_LRM_EXT_TRG=1};     // external trigger

enum LineTriggerGateMode {
	_LRM_NON_GATED=0,    //  no image trigger        
	_LRM_GATED_COUNT=1,  //  image trigger rising edge starts sampling         
	_LRM_GATED_PARTIAL=2, // image sampling during gate active. if the gate 
							//signal exceeds AreaHeight number of lines, the 
							//transfer is completed by an EoT, but continues 
							//(Image Tag Bit 31 is 0 if the next frame belongs to the same image strip)
	_LRM_GATED=3};       //  image sampling during gate active

enum TriggerSync    {_LVAL=0,_HDSYNC=1};

enum CCsel {CC_EXSYNC,CC_HDSYNC,CC_STROBEPULSE,CC_CLK,CC_GND,CC_VCC,CC_NOT_EXSYNC,CC_NOT_HDSYNC,CC_NOT_STROBEPULSE};

enum MeTriggerMode{
	FREE_RUN						= 0,
	GRABBER_CONTROLLED				= 1,
	ASYNC_TRIGGER					= 2,
	GRABBER_CONTROLLED_SYNCHRON		= 3,
	ASYNC_SOFTWARE_TRIGGER			= 4,
	ASYNC_GATED						= 5,
	ASYNC_GATED_MULTIFRAME			= 6
};

enum MeLineTriggerMode{
	GRABBER_CONTROLLED_GATED		= 6
};

enum MeShaftMode {
	SOURCE_A		= 0, 
	SOURCE_B		= 1
};
enum MeLineShadingMode{
	SHADING_OFF			= 0,
	SHADING_SUB			= 1,
	SHADING_MULT		= 2,
	SHADING_SUB_MULT	= 3
};

enum MeKneeLutMode{
	FG_INDEP		= 0,
	FG_DEP			= 1
};

enum MeAreaTriggerMode{
	AREA_FREE_RUN					= 0,
	AREA_GRABBER_CONTROLLED			= 1,
	AREA_ASYNC_TRIGGER				= 2,
	AREA_GRABBER_CONTROLLED_SYNCHRON= 3,
	AREA_ASYNC_SOFTWARE_TRIGGER		= 4
};

enum MeLineTriggerModeLine{
	LINE_FREE_RUN_LINE						= 0,
	LINE_GRABBER_CONTROLLED_LINE			= 1,
	LINE_ASYNC_TRIGGER_LINE					= 2,
	LINE_ASYNC_GATED_LINE					= 5,
	LINE_GRABBER_CONTROLLED_GATED_LINE		= 6
};

enum MeLineTriggerModeImage{
	LINE_FREE_RUN_IMAGE						= 0,
	LINE_GRABBER_CONTROLLED_IMAGE			= 1,
	LINE_ASYNC_TRIGGER_IMAGE				= 2,
	LINE_GRABBER_CONTROLLED_GATED_IMAGE		= 5,
	LINE_ASYNC_GATED_MULTIBUFFERS_IMAGE		= 6
};




enum  MeCameraLinkFormat {
	FG_CL_SINGLETAP_8_BIT		= 8,
	FG_CL_SINGLETAP_10_BIT		= 10,
	FG_CL_SINGLETAP_12_BIT		= 12,
	FG_CL_SINGLETAP_14_BIT		= 14,
	FG_CL_SINGLETAP_16_BIT		= 16,
	FG_CL_DUALTAP_8_BIT			= 108,
	FG_CL_DUALTAP_10_BIT		= 110,
	FG_CL_DUALTAP_12_BIT		= 112,
	FG_CL_RGB					= 500,
	FG_CL_MEDIUM_8_BIT			= 208,
	FG_CL_MEDIUM_10_BIT			= 210,
	FG_CL_MEDIUM_12_BIT			= 212,
	FG_CL_MEDIUM_RGB_24			= 214,
	FG_CL_MEDIUM_RGB_30			= 216,
	FG_CL_MEDIUM_RGB_36			= 218

};


enum MeCameraTypes {
	FG_AREA_GRAY					= 0,
	FG_AREA_BAYER					= 1,
	FG_LINE_GRAY					= 2,
	FG_SINGLE_LINE_RGB				= 3,
	FG_DUAL_LINE_RGB				= 4,
	FG_SINGLE_AREA_RGB				= 5,
	FG_DUAL_AREA_RGB				= 6,
	FG_AREA_HSI						= 7,
	FG_DUAL_LINE_RGB_SHADING		= 8,
	FG_SINGLE_LINE_RGBHSI			= 9,
	FG_SINGLE_AREA_RGB_SEPARATION	= 10,
	FG_MEDIUM_LINE_RGB				= 11,
	FG_MEDIUM_LINE_GRAY				= 12,
	FG_MEDIUM_AREA_GRAY				= 13,
	FG_MEDIUM_AREA_RGB				= 14,
	FG_AREA_GRAY12					= 15,
	FG_SEQUENCE_EXTRACTOR_A			= 16,
	FG_SEQUENCE_EXTRACTOR_B			= 17,
	FG_LINE_GRAY12					= 18,
	FG_AREA_RGB36					= 19,
	FG_DUAL_LINE_RGB_SORTING		= 20,
	FG_DUAL_LINE_GRAY12				= 21,
	FG_MEDIUM_LINE_GRAY12			= 22,
	FG_SINGLE_AREA_GRAY12			= 23,
	FG_2D_SHADING_12				= 24
};

enum MeSensorReadoutModes2{
	SMODE_UNCHANGED			= 0,
	SMODE_REVERSE			= 3,
	SMODE_TAB2_0			= 1,
	SMODE_TAB2_1			= 4,
	SMODE_TAB2_2			= 6,
	SMODE_TAB4_0			= 2,
	SMODE_TAB4_1			= 5,
	SMODE_TAB4_2			= 7
};
///////////////////////////////////////////////////////////////////////////////////////////////
// 
// Defines  
//

#define FG_NO		0
#define FG_YES		1

#define FG_LOW		0
#define FG_HIGH		1

#define	 FG_FALLING 1
#define	 FG_RISING  0

#define FG_ON		1
#define FG_OFF		0

#define FG_SAVE_LUT_TO_FILE		1
#define FG_LOAD_LUT_FROM_FILE	0

#define FG_0_BIT	0
#define FG_1_BIT	1
#define FG_2_BIT	2
#define FG_3_BIT	3
#define FG_4_BIT	4
#define FG_5_BIT	5
#define FG_6_BIT	6
#define FG_7_BIT	7
#define FG_8_BIT	8
#define FG_9_BIT	9
#define FG_10_BIT	10
#define FG_11_BIT	11
#define FG_12_BIT	12
#define FG_13_BIT	13
#define FG_14_BIT	14
#define FG_15_BIT	15
#define FG_16_BIT	16
#define FG_17_BIT	17
#define FG_18_BIT	18
#define FG_19_BIT	19
#define FG_20_BIT	20
#define FG_21_BIT	21
#define FG_22_BIT	22
#define FG_23_BIT	23
#define FG_24_BIT	24
#define FG_25_BIT	25
#define FG_26_BIT	26
#define FG_27_BIT	27
#define FG_28_BIT	28
#define FG_29_BIT	29
#define FG_30_BIT	30
#define FG_31_BIT	31
#define FG_32_BIT	32
#define FG_36_BIT	36
#define FG_48_BIT	48

#define FG_MSB		0
#define FG_LSB		1

//#define FG_CAMSTATUS 2000

#define MAX_BUF_NR 1048576

#define CONTMODE			0x10
#define HANDSHAKEMODE		0x20
#define BLOCKINGMODE		HANDSHAKEMODE
#define PULSEMODE			0x30


// Bildformate
#define FG_GRAY					3
#define FG_GRAY_PLUS_PICNR		30
#define FG_GRAY16				1
#define FG_GRAY16_PLUS_PICNR	10
#define FG_COL24				2
#define FG_COL32				4
#define FG_COL30				5
#define FG_COL48				6			

// acquire formats
#define ACQ_STANDARD	0x1
#define ACQ_BLOCK		0x2
#define ACQ_PULSE		0x4

// STATUS Parameter
#define NUMBER_OF_GRABBED_IMAGES		10	// Anzahl bislang aufgenommener Bilder
#define NUMBER_OF_LOST_IMAGES			20	// Anzahl der verlorenen Bilder
#define NUMBER_OF_BLOCK_LOST_IMAGES		30	// Anzahl der Bilder, die durch das blockieren von Speicher
											// verloren gegangen sind
#define NUMBER_OF_BLOCKED_IMAGES		40	// Anzahl der Blockierten Bilder
#define NUMBER_OF_ACT_IMAGE				50	// Nummer des zuletzt aufgenommenen Bildes
#define NUMBER_OF_LAST_IMAGE			60	// Nummer des zuletzt abgeholten Bildes
#define NUMBER_OF_NEXT_IMAGE			70	// Nummer des nchsten Bildes nach dem zuletzt abgeholten Bild 
#define NUMBER_OF_IMAGES_IN_PROGRESS	80	// Anzahl der Bilder die noch nicht abgeholt wurden 

#define BUFFER_STATUS					90	// Status des Buffers, Free, Blocked, 
#define GRAB_ACTIVE						100	// Status der Aufnahme, Stopped, Grabbing

#define FG_REVNR						99

#define FG_BLOCK						0x100
#define FG_UNBLOCK						0x200
#define FG_UNBLOCK_ALL					0x220
#define FG_PULSE_NEXT_BUFFER			0x230

#define SEL_ACT_IMAGE		200
#define SEL_LAST_IMAGE		210
#define SEL_NEXT_IMAGE		220
#define SEL_NUMBER			230
#define SEL_NEW_IMAGE		240

// +-- PARAMETER --+



//#define FG_REVNR	99
#define FG_WIDTH	100
#define FG_HEIGHT	200

#define FG_MAXWIDTH		6100
#define FG_MAXHEIGHT	6200
#define FG_ACTIVEPORT	6300

#define FG_XOFFSET			300
#define FG_YOFFSET			400
#define FG_XSHIFT			500
#define FG_TIMEOUT			600
#define FG_FORMAT			700
#define FG_CAMSUBTYP		80
#define FG_FRAMESPERSEC		90
#define FG_MAXFRAMESPERSEC	91
#define FG_MINFRAMESPERSEC	92
#define FG_LINESPERSEC		95
#define FG_LINEPERIODE		96

#define FG_EXPOSURE			10020			// Exposure Time in s (Brigthness)	(float)
#define FG_LINEEXPOSURE		10030
#define FG_HDSYNC			10050

#define FG_PRESCALER		FG_HDSYNC
#define FG_LINETRIGGER		FG_HDSYNC

#define FG_RS232PARON		10060


#define FG_PIXELDEPTH				4000
#define FG_BITALIGNMENT				4010
#define FG_LINEALIGNMENT			4020

#define FG_CAMBITWIDTH				5000
#define FG_CAMBITSHIFT				5010
#define FG_SHIFTCAMDATARIGHT		5020
#define FG_ROTATECAMDATA			FG_SHIFTCAMDATARIGHT // compatibility mode
#define FG_USEDVAL					5025
//#define FG_TAPFORMAT				5026
#define FG_SWAPENDIAN				5028
#define FG_MASKCAMDATA				5030
#define FG_ADDOFFSET				5035
#define FG_DROPPEDIMAGEES			5040
#define FG_SENSORREADOUT			5050
#define FG_SENSORREADOUT_TAPS		5051
#define FG_SENSORREADOUT_DIREC		5052

#define FG_TRIGGERMODE				8100
#define FG_LINETRIGGERMODE			8102
#define FG_IMGTRIGGERMODE			8104
#define FG_IMGTRIGGERON				8106
#define FG_TRIGGERINSRC				8110
#define FG_LINETRIGGERINSRC			8112
#define FG_IMGTRIGGERINSRC			8113
#define FG_LINETRIGGERINPOLARITY	8115
#define FG_IMGTRIGGERINPOLARITY		8116
#define FG_TRIGGERINPOLARITY		FG_IMGTRIGGERINPOLARITY
#define FG_IMGTRIGGERGATEDELAY		8118
#define FG_USEROUT					8120
#define FG_EXSYNCINVERT				8200
#define FG_EXSYNCON					8300
#define FG_EXSYNCDELAY				8400
#define FG_EXSYNCPOLARITY			8420
#define FG_DEADTIME					8450
#define FG_DEADTIME_OFFSET			8460
#define FG_BGRRGBORDER				8500
#define FG_FLASHON					8600
#define FG_SENDSOFTWARETRIGGER		8800
#define FG_SETSOFTWARETRIGGER		8801
#define FG_LINETRIGGERDELAY			8900
#define FG_TRIGGERMASTERSYNC		9000

#define FG_SHAFTENCODERINSRC		9100
#define FG_SHAFTENCODERON			9110
#define FG_SHAFTENCODERLEADING		9120

#define FG_CAMSTATUS			2000
#define FG_CAMSTATUS_EXTENDED	2050
#define FG_TWOCAMMODEL			2100
#define FG_PORT					3000

#define FG_TRANSFER_LEN			5210

#define FG_STROBEPULSEDELAY		8700
#define FG_STROBEPULSEREDUCE	8710
#define FG_STROBEPULSESRCSEL	8720
#define FG_STROBEPULSEINVERT	8730

//#define  FG_DUALTAP 11010
#define FG_CAMERA_LINK_CAMTYP			11011
#define FG_CL_CAMTYP					11011



#define FG_LOOKUPTABLE					12000
#define FG_LUT_FILE						12010
#define FG_LUT_SAVE_LOAD_FILE			12020

#define FG_KNEE_LUT						12100
#define FG_KNEE_LUT_FILE				12110
#define FG_KNEE_LUT_SAVE_LOAD_FILE		12120
#define FG_KNEE_LUT_MODE				12130
#define FG_KNEE_LUT_ACCESS				12140

#define FG_KNEE_LUT_SCALE				12101
#define FG_KNEE_LUT_OFFSET				12102
#define FG_KNEE_LUT_GAMMA				12103
#define FG_KNEE_LUT_INVERT				12104

#define FG_2DSHADINGPARAMETER			12500

#define FG_SCALINGFACTOR_RED			13000
#define FG_SCALINGFACTOR_BLUE			13010
#define FG_BAYERINIT					13020
#define FG_SCALINGFACTOR_GREEN			13030

#define FG_CCSEL						14000
#define FG_CCSEL0						14001
#define FG_CCSEL1						14002
#define FG_CCSEL2						14003
#define FG_CCSEL3						14004

#define FG_CCSEL_INVERT					14005
#define FG_CCSEL_INVERT0			    14006
#define FG_CCSEL_INVERT1				14007
#define FG_CCSEL_INVERT2				14008
#define FG_CCSEL_INVERT3				14009

#define FG_DIGIO_INPUT					14010
#define FG_DIGIO_OUTPUT					14020

// for QNX pulses
#define FG_INTERRUPT_EVENT				20000

// version 2.2
#define FG_IMAGE_TAG					22000
#define FG_TIMESTAMP					22020
#define FG_TIMESTAMP_LONG				22030

#define FG_LICENSESTRING0				23000
#define FG_LICENSESTRING1				23010
#define FG_LICENSESTRING2				23020

#define FG_ROIX							23100
#define FG_ROIY							23110
#define FG_SHADING_SUBIMAGE				23120
#define FG_SHADING_MULTENABLE			23130
#define FG_SHADING_OFFSETENABLE			23140
#define FG_SHADING_SUBENABLE			FG_SHADING_OFFSETENABLE

#define FG_SHADING_MAX_MULT				23135

#define FG_SHADING_RUNSUBIMAGE0			23121
#define FG_SHADING_RUNSUBIMAGE1			23122
#define FG_SHADING_RUNSUBIMAGE2			23123
#define FG_SHADING_RUNSUBIMAGE3			23124

#define FG_SHADING_ENABLEMULT0			23131
#define FG_SHADING_ENABLEMULT1			23132
#define FG_SHADING_ENABLEMULT2			23133
#define FG_SHADING_ENABLEMULT3			23134

#define FG_SHADING_ENABLESUB0			23141
#define FG_SHADING_ENABLESUB1			23142
#define FG_SHADING_ENABLESUB2			23143
#define FG_SHADING_ENABLESUB3			23144

#define FG_SHADING_FPNENABLE			23150
#define FG_SHADING_ENABLEFPN0			23151
#define FG_SHADING_ENABLEFPN1			23152
#define FG_SHADING_ENABLEFPN2			23153
#define FG_SHADING_ENABLEFPN3			23154


#define FG_SHADING_THRESHOLD0			23156
#define FG_SHADING_THRESHOLD1			23157
#define FG_SHADING_THRESHOLD2			23158	
#define FG_SHADING_THRESHOLD3			23159

#define FG_SHADING_MULTFILE0			23160
#define FG_SHADING_SUBFILE0				23170
#define FG_SHADING_FPNFILE0				23180
#define FG_SHADING_MULTFILE1			23210
#define FG_SHADING_SUBFILE1				23225
#define FG_SHADING_FPNFILE1				23230
#define FG_SHADING_MULTFILE2			23240
#define FG_SHADING_SUBFILE2				23250
#define FG_SHADING_FPNFILE2				23260
#define FG_SHADING_MULTFILE3			23270
#define FG_SHADING_SUBFILE3				23280
#define FG_SHADING_FPNFILE3				23290

#define FG_CONTRAST						23200
#define FG_BRIGHTNESS					23220 


#define FG_LINE_DOWNSCALE				24040
#define FG_LINE_DOWNSCALEINIT			24050
#define FG_FLASH_POLARITY				24060
#define FG_FLASHDELAY					FG_STROBEPULSEDELAY		

#define FG_LOAD_SHADINGDATA				24070
#define FG_CLEAR_SHADINGDATA			24080


#define FG_LINESHADINGPARAMETER			24081
#define FG_1DSHADINGPARAMETER			FG_LINESHADINGPARAMETER

#define FG_LINESHADING_SUB_ENABLE		24082
#define FG_LINESHADING_MULT_ENABLE		24083
#define FG_ENABLEDISABLE_SHADING		FG_LINESHADING_MULT_ENABLE
#define FG_SHADING_WIDTH					24089
#define FG_AUTO_SHADING_WIDTH			24090
#define	FG_WRITE_SHADING_12				24091

#define FG_LINESHADING_MULT_FILENAME	24084
#define FG_LINESHADING_SUB_FILENAME		24085
#define FG_LINESHADING_LOAD_FROM_FILE	24086
#define FG_LINESHADING_MODE				24087

#define FG_DMASTATUS					24092
#define FG_LINEVALID_SIGNAL_COUNT		24093
#define FG_FRAMEVALID_SIGNAL_COUNT		24094

#define FG_1DSHADING_FILE				FG_LINESHADING_MULT_FILENAME//24095
#define FG_LOAD_1DSHADINGDATA			FG_LINESHADING_LOAD_FROM_FILE//24096

#define FG_BURSTLENGTH					24097
#define FG_SUPERFRAME					24098

#define FG_DOXYPARAM					24100
#define FG_HTML_OUTPUT					24101
#define FG_PLX_CLK						24102
#define FG_FPGA_CLK						24104
#define FG_HAP_FILE						24108

#define FG_GLOBAL_ACCESS				24110
#define FG_DOC_URL						24112
#define FG_PARAM_DESCR					24114

//// define from 200000 to 210000 are reserved for customer projects


#define FG_APPLET_ID			24010
#define FG_APPLET_VERSION		24020
#define FG_APPLET_REVISION		24030

// Define for Design CLK
#define FG_DESIGNCLK			24040
#define FG_ALL					24050

// Define for HSI param
#define FG_THRESHOLD_H_MIN		25000
#define FG_THRESHOLD_H_MAX		25010

#define FG_THRESHOLD_S_MIN		25020
#define FG_THRESHOLD_S_MAX		25030

#define FG_THRESHOLD_I_MIN		25040
#define FG_THRESHOLD_I_MAX		25050

#define FG_DO_THRESHOLD_S		25060
#define FG_DO_THRESHOLD_I		25070

#define FG_SHADING_H			25080
#define FG_SHADING_S			25090
#define FG_SHADING_I			25100

#define FG_FASTCONFIG_SEQUENCE	30010
#define FG_FASTCONFIG_PAGECMD	30020
#define FG_FASTCONFIG_PAGECMD_PTR	30030
#define FG_FASTCONFIG_PULSEDIGIO 30040

#define FG_IMG_SELECT_PERIOD	25110
#define FG_IMG_SELECT			25111

#define FG_NROFEXTERN_TRIGGER		30110
#define FG_ACTIVATE_EXTERN_TRIGGER	30120
#define FG_READ_EXTERN_TRIGGER		30130

#define FG_NB_QUAD_IMG				30300
#define FG_NB_STD_IMG				30310
				

// 
#define FG_CABLE_SELECT		1001010
#define FG_IMAGE_ENABLE		1001020
#define FG_STAT_ENABLE		1001030
#define FG_MIN_DX			1001040
#define FG_THR1				1001050
#define FG_THR2				1001060
#define FG_MEDIAN_ON		1001070
#define FG_DMA_WRITE		1001080
#define FG_FAST_CONFIG		1001090
#define FG_SYNC				1001100
#define FG_NODMA1IR			1001110


// LUT defines
#define LUT_RED			0
#define LUT_GREEN 		1
#define LUT_BLUE		2
#define LUT_GRAY 		3

#define PORT_A		0
#define PORT_B		1
#define PORT_AB		2

#define FG_RED		0
#define FG_GREEN	1
#define FG_BLUE		2

#define TRGINSOFTWARE -1
#define TRGINSRC_0	0
#define TRGINSRC_1	1
#define TRGINSRC_2	2
#define TRGINSRC_3	3

#define GRAB_INFINITE -1

#define STOP_SYNC	0x80000000
#define STOP_ASYNC	0

// Error def.		 
#define		FG_INIT_OK						1 
#define		FG_OK 							0 
#define		FG_ERROR 						-1 

#define		FG_DUMMY_BUFFER					-1 
#define		FG_NO_PICTURE_AVAILABLE 		-2
 
#define     FG_ALR_INIT 						-10 
#define     FG_NOT_AVAILABLE 					-12 
#define     FG_NO_BOARD_AVAILABLE 				-20 
#define     FG_WRONG_ARCHITECTURE 				-50 
#define     FG_SOFTWARE_TRIGGER_BUSY			-60
#define     FG_HAP_FILE_NOT_LOAD				-100
#define     FG_MICROENABLE_NOT_INIT				-110
#define     FG_DLL_NOT_LOAD						-120
#define     FG_SIZE_ERROR 						-200 
#define     FG_PTR_INVALID 						-300 
#define     FG_RANGE_ERR 						-400 
#define     FG_NOT_ENOUGH_MEM					-500 
#define     FG_DMATRANSFER_INVALID				-600 

#define     FG_NOT_INIT 						-2001 
#define     FG_WRONG_SIZE 						-2002
//#define     FG_LIB_UNLOAD_FAIL				-2003 
#define     FG_WRONG_NUMBER_OF_BUFFER 			-2010 
#define     FG_TOO_MANY_BUFFER 					-2011 
#define     FG_NOT_ENOUGH_MEMORY 				-2020 
#define     FG_MEMORY_ALREADY_ALLOCATED			-2024 
#define		FG_CANNOT_WRITE_MEM_CONFIG_FAILED	-2026     
#define     FG_INTERNAL_STATUS_ERROR 			-2030 
#define     FG_INTERNAL_ERROR 					-2031 
#define     FG_CANNOT_START						-2040 
#define     FG_CANNOT_STOP 						-2042 
#define     FG_SYNC_ACQUIRE_NOT_SUPPORTED		-2045
#define     FG_INVALID_DESIGN 					-2050 
#define     FG_CONFIGURE_FAILED 				-2052 
#define     FG_RECONFIGURE_FAILED 				-2053 
#define		FG_NO_APPLET_ID 					-2055 
//#define		FG_APPLET_NOT_IN_LIST 			-2056 

#define     FG_INVALID_MEMORY 					-2060 
#define     FG_INVALID_PARAMETER 				-2070 
#define     FG_PARAM_INVALID 					FG_INVALID_PARAMETER	

#define		FG_INVALID_VALUE					-2075 
#define		FG_INVALID_FILENAME					-2076
#define		FG_INVALID_REGISTER					-7040
#define		FG_INVALID_MODULO					-7080
#define		FG_INVALID_CONFIGFILE				-5000 
#define		FG_INVALID_CONFIGFILEEXT			FG_INVALID_CONFIGFILE	 

#define     FG_NOT_LOAD 						-2080 
#define     FG_ALREADY_STARTED 					-2090 
#define     FG_STILL_ACTIVE 					-2100 
#define     FG_NO_VALID_DESIGN 					-2110 
#define     FG_TIMEOUT_ERR 						-2120 
#define     FG_NOT_IMPLEMENTED 					-2130 
#define     FG_NOT_WRONG_TRIGGER_MODE			-2140
#define     FG_ALL_BUFFER_BLOCKED				-2150 
#define     FG_CANNOT_INIT_MICROENABLE 			-3000 
#define     FG_TRANSFER_NOT_ACTIVE 				-3010 
#define     FG_CLOCK_NOT_LOCKED					-3120 
#define     FG_STILL_NOT_STARTED 				-4000 
#define		FG_VALUE_OUT_OF_RANGE				-6000
#define		FG_CANNOT_CHANGE_DISPLAY_WIDTH		-7000
#define		FG_CANNOT_CHANGE_DISPLAY_HEIGHT		-7005
#define		FG_CANNOT_CHANGE_DISPLAY_SIZE		-7010
#define     FG_NO_VALID_LICENSE 				-7020
#define		FG_CANNOT_CHANGE_CAMERA_FORMAT		-7030
#define		FG_REGISTER_INIT_FAILED				-7050
#define		FG_INVALID_SHADING_CORRECTION_FILE	-7060
#define		FG_WRITE_LINE_SHADING_TIMEOUT		-7070
#define     FG_CANNOT_CHANGE_DURING_ACQU		-7090
#define		FG_TOKEN_NOT_FOUND_ERROR			-8000
#define     FG_WRITE_ACCESS_DENIED				-8010
#define     FG_REGISTER_UPDATE_FAILED			-8020


///////////////////////////////////////////////////////////////////

#define DLL_TYP						0x100
#define GET_FOR_MANUFACTOR_STRING	0x200 //old name
#define GET_MANUFACTURER_STRING		0x200
#define GET_MANUFACTOR_STRING		0x200
#define GET_CAMERA_STRING			0x300 //old name
#define GETCAMERASTRING				0x300 //old old name
#define GET_APPLET_STRING			0x300
#define GET_ISCAM_COLOR             0x350
#define SET_DLL_PARAM				0x400

#define GET_NR_OF_GENFUNCS			0x500
#define GET_GENFUNCNAME				0x600
#define GET_NR_OF_PORTS				0x700
#define GET_NR_OF_CAMS				0x750
#define GET_VERSION					0x800
#define GET_LICENSE_INFO			0x900
#define GET_IS_CUSTOM				0xa00
#define GET_IS_AREA					0xb00

#define SINGLE_AREA_GRAY			0x10
#define SINGLE_AREA_2DSHADING		0x11
#define DUAL_AREA_GRAY				0x20
#define SINGLE_AREA_BAYER			0x30
#define DUAL_AREA_BAYER				0x31
#define SINGLE_AREA_GRAY_SHADING	0x40
#define SDRAM_ACCESS				0x41
#define SINGLE_LINE_GRAY			0x50
#define SINGLE_LINE_RGB				0x60
#define DUAL_LINE_RGB				0x61
#define DUAL_LINE_RGB_SHADING		0x62
#define DUAL_LINE_GRAY				0x70
#define VISIGLAS					0x80
#define TRUMPFINESS					0x81
#define SOUDRONIC					0x82
#define SINGLEHIGHPRECISION			0x83
#define SINGLE_AREA_GRAY_OFFSET		0x84
#define SINGLE_AREA_HSI				0x90
#define SINGLE_AREA_RGB				0xa0
#define DUAL_AREA_RGB				0xb0
#define SINGLE_AREA_RGB_SEPARATION	0xb1
#define MEDIUM_LINE_RGB				0xb2
#define MEDIUM_LINE_GRAY			0xb3
#define SINGLE_FAST_CONFIG			0xb5
#define	FASTCONFIG_SINGLE_AREA_GRAY SINGLE_FAST_CONFIG

#define SINGLE_AREA_GRAY_XXL		0x110
#define SINGLE_AREA_2DSHADING_XXL	0x111
#define DUAL_AREA_GRAY_XXL			0x120
#define SINGLE_AREA_BAYER_XXL		0x130
#define DUAL_AREA_BAYER_XXL			0x131
#define SINGLE_AREA_GRAY_SHADING_XXL 0x140
#define SDRAM_ACCESS_XXL			0x141
#define SINGLE_LINE_GRAY_XXL		0x150
#define SINGLE_LINE_RGB_XXL			0x160
#define DUAL_LINE_RGB_XXL			0x161
#define DUAL_LINE_RGB_SHADING_XXL	0x162
#define DUAL_LINE_GRAY_XXL			0x170
#define SINGLE_AREA_HSI_XXL			0x190
#define SINGLE_AREA_RGB_XXL			0x1a0
#define DUAL_AREA_RGB_XXL				0x1b0
#define SINGLE_AREA_RGB_SEPARATION_XXL	0x1b1
#define MEDIUM_LINE_RGB_XXL			0x1b2
#define MEDIUM_LINE_GRAY_XXL		0x1b3
#define MEDIUM_AREA_GRAY_XXL		0x1b4
#define MEDIUM_AREA_RGB_XXL			0x1b5
#define SINGLE_AREA_BAYER12_XXL		0x1c0
#define DUAL_AREA_GRAY12_XXL		0x1d0
#define SINGLE_LINE_GRAY12_XXL		0x1d1
#define DUAL_AREA_RGB36_XXL			0x1d2
#define DUAL_LINE_GRAY12_XXL		0x1d3
#define MEDIUM_LINE_GRAY12_XXL		0x1d4
#define SINGLE_AREA_GRAY12_XXL		0x1d5
#define DUAL_LINE_RGB36_XXL			0x1d6
#define SINGLE_AREA_RGB36_XXL		0x1d7
#define SINGLE_LINE_RGB36_XXL		0x1d8
#define DUAL_AREA_BAYER12_XXL		0x1d9
#define SINGLE_AREA_2DSHADING12_XXL	0x1da

#define LSC1020XXL					0x500
#define LSC1020JPGXXL				0x501
#define SEQUENCE_EXTRACTOR			0x510
#define SAG_COMPRESSION				0x520
#define MEDIUM_LINE_GRAY_FIR_XXL	0x530
#define DUAL_LINE_RGB_SORTING_XXL	0x540

#endif
