//+-------------------------------------------------------------------
//
//  
//  Copyright (C) Silicon Software GmbH, 1999.
//
//  File:       mem_siso.h
//
//  Contents:
//
//
//
//--------------------------------------------------------------------

#ifndef __MEM_SISO1H
#define __MEM_SISO1H

#include "os_type_1.h"

class dma_mem {
public:
	dma_mem(){
		mem					= NULL;
		aPFNs				= NULL;
		UserBuffer			= NULL;
		UserBufferIsLocked	= NULL;
		internalBuffer		= NULL;
		dmaStatus			= DMA_STOPPED;
	}
	int flag;	// USER_BUFFER, LOCKED_BUFFER
	unsigned long *mem;
#ifdef LINUX
        unsigned long *user_mem;
#endif
	int		size;
	int		max_sub_size;
	int		nr_of_subbuf;
	int		virt_buffer_nr;
	ULONG*	aPFNs;
	int		NrOfPages;
	int		isInitialized;
	UCHAR**	UserBuffer;
	UCHAR*	UserBufferIsLocked;
	UCHAR*	internalBuffer;
	long    internalBufferOffset;
	int		nDir;
	int		dmaChannel;	// 0,1
	int		dmaStatus;	// DMA_STOPPED=0, DMA_STARTED=1
	enum    {DMA_STOPPED,DMA_STARTED};
};


#define ME_USER_BUFFER 0x100
#define ME_LOCKED_BUFFER 0x200
#define ME_PHYSICAL_LINE_BUFFER 0x300
#define ME_LOCKEDUSER_BUFFER 0x400


// ===================================================
// 
// Prototypes
//
// ===================================================


#endif


