//+-------------------------------------------------------------------
//
//  MicroEnable Io Library
//  Copyright (C) Silicon Software GmbH, 1997-2005
//
//  File:       sisoIoAvi.h
//
//  Description:   
//              
//
//
//--------------------------------------------------------------------

#ifndef _SISOIO_H
#define _SISOIO_H

#include <windows.h>
#include <stdio.h>
#include <vfw.h>

//#define dlldir __declspec( dllimport)
#define dlldir

extern "C" dlldir int IoCreateAVIGray(void **AviRef,char *filename,int width,int height,double fps);
extern "C" dlldir int IoCreateAVIGrayW(void **AviRef,LPCWSTR filename,int width,int height,double fps);
extern "C" dlldir int IoCreateAVIColor(void **AviRef,char *filename,int width,int height,double fps);
extern "C" dlldir int IoCreateAVIColorW(void **AviRef,LPCWSTR filename,int width,int height,double fps);
extern "C" dlldir int IoWriteAVIPicture(void *AviRef,int PicNr,unsigned char *buffer);
extern "C" dlldir int IoCloseAVI(void *AviRef);

extern "C" dlldir void *IoReadBmp(const char *name,unsigned char **data,int *width,int *height,int *bits);
extern "C" dlldir int IoCloseBmp(void *bmpHandle);
extern "C" dlldir int IoWriteBmp(char *name,unsigned char *data,int width,int height,int bits);
extern "C" dlldir int IoWriteBmpW(LPCWSTR filename,unsigned char *data,int width,int height,int bits);

extern "C" dlldir int IoWriteRaw(char *name,unsigned char *data,int width,int height,int bits);
extern "C" dlldir int IoWriteRawW(LPCWSTR filename,unsigned char *data,int width,int height,int bits);
extern "C" dlldir int IoReadRaw(char *name,unsigned char**data,int *width,int *height,int *bits);
extern "C" dlldir int IoFreeRaw(unsigned char *data);

// Erzeugung einer neuen Sequenzdatei
extern "C" dlldir int IoCreateSeq(void **SeqRef,char *pFilename,int width,int height,int bitdepth,int format);
// Speichern eines Bildes auf Platte
extern "C" dlldir int IoWriteSeqPicture(void *SeqRef,int PicNr,unsigned char *buffer);
// Schliessen der Datei
extern "C" dlldir int IoCloseSeq(void *SeqRef);

// ffnen der Datei
extern "C" dlldir int IoOpenSeq(HANDLE *SeqRef,char *pFilename,int* width,int* height,int* bitdepth,int mode);
// Info ber Datei
extern "C" dlldir int IoGetSeqInfo(void *SeqRef,int *nrOfImages,int *nrOfLostImages);
// Bild mit der Nummer PicNr aus Datei lesen
extern "C" dlldir int IoReadSeqPicture(void *SeqRef,int PicNr,unsigned char *buffer);
// Nchstes Bild aus Datei Lesen
extern "C" dlldir int IoReadNextSeqPicture(void *SeqRef,int* PicNr,unsigned char *buffer);
// lese Bild StartPicNr bis StopPicNr aus Sequenzdatei und speichere diese als Avi ab
extern "C" dlldir int IoSeqCreateAvi(void *SeqRef,char* aviFilename,int StartPicNr,int StopPicNr);


extern "C" dlldir int IoWriteTiff(char *name,unsigned char *data,int width,int height,int bitPerSample,int samplePerPixel);
extern "C" dlldir int IoWriteTiffW(LPCWSTR filename,unsigned char *data,int width,int height,int bitPerSample,int samplePerPixel);
extern "C" dlldir void *IoReadTiff(char *name,unsigned char**data,int *width,int *height,int *bitPerSample,int *samplePerPixel);
extern "C" dlldir void *IoReadTiffW(LPCWSTR filename,unsigned char**data,int *width,int *height,int *bitPerSample,int *samplePerPixel);
extern "C" dlldir int IoFreeTiff(unsigned char *data);
#endif
